import java.io.*;
import java.util.*;

public class Main {

    public static void main(String[] args) throws IOException {
        int n = nextInt();
        int m = nextInt();
        char[][] a = new char[n][6];
        for (int i = 0; i < n; i++) {
            String s = nextToken();
            a[i] = s.toCharArray();
        }
        int t = 0;
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < 6; j++) {
                if (a[i][j] == 'X') {
                    if (a[i][5 - j] == '.') {
                        if (m == 0) {
                            t = 1;
                            break;
                        }
                        a[i][5 - j] = 'X';
                        m--;
                    }
                }
            }
            if (t == 1) break;
        }
        if (t == 1) {
            out.println("Impossible");
            out.close();
            return;
        }
        if (m % 2 == 1) {
            out.println("Impossible");
            out.close();
            return;
        }
        int sum = 0;
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < 3; j++) {
                if (m == 0) break;
                if (a[i][j] == '.') {
                    a[i][j] = 'X';
                    a[i][5 - j] = 'X';
                    m -= 2;
                }
            }
        }
        if(m > 0) {
            out.println("Impossible");
            out.close();
            return;
        }
        for (int i = 0; i < n; i++) {
            out.println(a[i]);
        }
        out.close();
    }

    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter out = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");


    public static boolean hasNext() throws IOException {
        if (in.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            in = new StringTokenizer(s);
            if (in.hasMoreTokens()) return true;
        }
        return false;
    }

    public static String nextToken() throws IOException {
        while (!in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}