import java.io.*;
import java.util.*;

public class Main {

    public static void main(String[] args) throws IOException {
        int n = nextInt();
        int[] a = new int[n];
        for (int i = 0; i < n; i++) {
            a[i] = nextInt();
        }
        int[] dp = new int[n];
        dp[0] = 1;
        for (int i = 1; i < n; i++) {
            if(a[i] < a[i-1]) {
                dp[0] ++;
            } else {
                break;
            }
        }
        long ans = 0;
        for (int i = 1; i < n; i++) {
            dp[i] = 1;
            if(a[i] > a[i-1]) {
                dp[i] += dp[i-1];
            }
            int sum = 1;
            for (int j = i+1; j < n; j++) {
                if(a[j] < a[j-1]) {
                    sum++;
                } else {
                    break;
                }
            }
            dp[i] *= sum;
        }
        for (int i = 0; i < n; i++) {
            ans += dp[i];
        }
        out.println(ans);
        out.close();
    }

    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter out = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");


    public static boolean hasNext() throws IOException {
        if (in.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            in = new StringTokenizer(s);
            if (in.hasMoreTokens()) return true;
        }
        return false;
    }

    public static String nextToken() throws IOException {
        while (!in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}