import java.io.*;
import java.util.*;

public class Main {

    public static boolean isPrime(int n) {
        int t = 0;
        for (int i = 2; i <= Math.sqrt(n); i++) {
            if (n % i == 0) {
                t = 1;
                break;
            }
        }
        if (t == 0) {
            return false;
        }
        return true;
    }

    public static void main(String[] args) throws IOException {
        int n = nextInt();
        int m = nextInt();
        int[][] a = new int[n][2];
        for (int i = 0; i < n; i++) {
            a[i][0] = nextInt();
        }
        for (int i = 0; i < n; i++) {
            a[i][1] = nextInt();
        }
        Arrays.sort(a, Comparator.comparingInt(arr -> arr[0]));
        ArrayList<Integer> x = new ArrayList<>();
        int i = 1;
        int h = 0;
        for (;; i++) {
            for (int j = 0; j < x.size(); j++) {
                x.set(j, x.get(j)+1);
            }
            long sum = 0;
            for (int j = 0; j < x.size(); j++) {
                if(x.get(j) >= 0) { 
                    sum += (long)Math.pow(2, x.get(j));
                } else {
                    sum++;
                }
            }
            if(sum == m) {
                out.println(i-1);
                out.close();
                return;
            }
            if(sum > m) {
                out.println(-1);
                out.close();
                return;
            }
            while(a[h][0] == i) {
                x.add(a[h][1] * -1);
                h++;
            }
        }
    }

    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter out = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");


    public static boolean hasNext() throws IOException {
        if (in.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            in = new StringTokenizer(s);
            if (in.hasMoreTokens()) return true;
        }
        return false;
    }

    public static String nextToken() throws IOException {
        while (!in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}