import java.io.*;
import java.util.*;

public class Main {

    public static boolean isPrime(int n) {
        int t = 0;
        for (int i = 2; i <= Math.sqrt(n); i++) {
            if (n % i == 0) {
                t = 1;
                break;
            }
        }
        if (t == 0) {
            return false;
        }
        return true;
    }

    public static void main(String[] args) throws IOException {
        int n = nextInt();
        int m = nextInt();
        long[][] a = new long[n][3];
        for (int i = 0; i < n; i++) {
            a[i][0] = nextInt();
        }
        for (int i = 0; i < n; i++) {
            a[i][1] = nextInt();
            a[i][2] = a[i][0] + a[i][1];
        }
        long l = -1;
        long r = Long.MAX_VALUE;
        long ans = 0;
        while(l+1 < r) {
            long x = (l+r) /2;
            long sum = 0;
            int t = 0;
            for (int i = 0; i < n; i++) {
                if(a[i][0] < x) {
                    if(x - a[i][2] >= 0) {
                        if(x-a[i][2] >= 31) {
                            r = x;
                            t = 1;
                            break;
                        }
                        sum += (long)Math.pow(2, (x-a[i][2]));
                    } else {
                        sum++;
                    }
                }
            }
            if(t == 1) {
                continue;
            }
            if(sum > m) {
                r = x;
            } else {
                l = x;
                ans = sum;
            }
        }
        if(ans == m) {
            out.println(l-1);
        } else {
            out.println(-1);
        }
        out.close();
    }

    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter out = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");


    public static boolean hasNext() throws IOException {
        if (in.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            in = new StringTokenizer(s);
            if (in.hasMoreTokens()) return true;
        }
        return false;
    }

    public static String nextToken() throws IOException {
        while (!in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}