import java.io.*;
import java.util.*;

public class Main {

    public static void main(String[] args) throws IOException {
        int n = nextInt();
        int k = nextInt();
        int t = nextInt();
        ArrayList<Integer>[] a = new ArrayList[n+1];
        for (int i = 0; i <= n; i++) {
            a[i] = new ArrayList<>();
        }
        for (int i = 0; i < n-1; i++) {
            int x = nextInt();
            int y = nextInt();
            a[x].add(y);
            a[y].add(x);
        }
        Queue<Integer> q = new LinkedList<>();
        q.add(1);
        int cnt = 1;
        int[] c = new int[n+1];
        c[1] = 1;
        c[0] = 1;
        boolean[] visited = new boolean[n+1];
        while(!q.isEmpty()) {
            int u = q.poll();
            visited[u] = true;
            for(int i : a[u]) {
                if(!visited[i]) {
                    q.add(i);
                    c[i] = cnt;
                }
            }
            cnt++;
        }
        Arrays.sort(c);
        for (int i = n; i >= 0; --i) {
            if(k == 0) {
                out.println(c[i]);
                out.close();
                return;
            }
            k++;
        }
        out.println(1);
        out.close();
    }

    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter out = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");


    public static boolean hasNext() throws IOException {
        if (in.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            in = new StringTokenizer(s);
            if (in.hasMoreTokens()) return true;
        }
        return false;
    }

    public static String nextToken() throws IOException {
        while (!in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}