import java.io.*;
import java.util.*;

public class Main {

    public static boolean isPrime(int n) {
        int t = 0;
        for (int i = 2; i <= Math.sqrt(n); i++) {
            if(n % i == 0) {
                t = 1;
                break;
            }
        }
        if(t == 1) {
            return true;
        }
        return false;
    }

    public static void main(String[] args) throws IOException {
        int n = nextInt();
        int[][] a = new int[n][2];
        for (int i = 0; i < n; i++) {
            a[i][0] = nextInt();
            a[i][1] = i;
        }
        Arrays.sort(a, Comparator.comparingInt(arr -> arr[0]));
        int[] ans = new int[n];
        Arrays.fill(ans, 2);
        ans[a[0][1]] = 1;
        for (int i = 1; i < n; i++) {
            if(a[i][0] % a[0][0] != 0) {
                ans[a[i][1]] = 1;
            } else {
                if(isPrime(a[i][0] / a[0][0])) {
                    ans[a[i][1]] = 1;
                }
            }
        }
        for (int i = 0; i < n; i++) {
            out.print(ans[i] + " ");
        }
        out.close();
    }

    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter out = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");


    public static boolean hasNext() throws IOException {
        if (in.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            in = new StringTokenizer(s);
            if (in.hasMoreTokens()) return true;
        }
        return false;
    }

    public static String nextToken() throws IOException {
        while (!in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}