import java.io.*;
import java.util.*;

public class Main {

    public static boolean isPrime(int n) {
        int t = 0;
        for (int i = 2; i <= Math.sqrt(n); i++) {
            if (n % i == 0) {
                t = 1;
                break;
            }
        }
        if (t == 0) {
            return false;
        }
        return true;
    }

    public static void main(String[] args) throws IOException {
        int n = nextInt();
        int m = nextInt();
        int[] a = new int[n];
        int[] t = new int[m+1];
        for (int i = 0; i < n; i++) {
            a[i] = nextInt();
            t[a[i]]++;
        }
        int x = 1;
        for (int i = 1; i <= m; i++) {
            if(t[i] != 0) {
                if(t[i] % 3 != 0) {
                    x = 0;
                    break;
                }
            }
        }
        int min = Integer.MAX_VALUE;
        if(m == 3) {
            for (int i = 1; i <= m; i++) {
                if (t[i] != 0) {
                    min = Math.min(min, t[i]);
                }
            }
        } else {
            min = 0;
        }
        for (int i = 1; i <= m; i++) {
            if(t[i] != 0) {
                t[i] -= min;
                if(t[i] % 3 != 0) {
                    out.println(x);
                    out.close();
                    return;
                }
            }
        }
        out.println(x+1);
        out.close();
    }

    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter out = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");


    public static boolean hasNext() throws IOException {
        if (in.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            in = new StringTokenizer(s);
            if (in.hasMoreTokens()) return true;
        }
        return false;
    }

    public static String nextToken() throws IOException {
        while (!in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}