import java.io.*;
import java.util.*;

public class Main {

    public static boolean isPrime(int n) {
        int t = 0;
        for (int i = 2; i <= Math.sqrt(n); i++) {
            if (n % i == 0) {
                t = 1;
                break;
            }
        }
        if (t == 0) {
            return false;
        }
        return true;
    }

    public static void main(String[] args) throws IOException {
        int n = nextInt();
        int m = nextInt();
        int[] a = new int[n];
        for (int i = 0; i < n; i++) {
            a[i] = nextInt();
        }
        if(m == 1) {
            out.println(1);
            out.close();
            return;
        }
        if(m == 2) {
            int t1 = 0;
            int t2 = 0;
            for (int i = 0; i < n; i++) {
                if(a[i] == 1) {
                    t1++;
                } else {
                    t2++;
                }
            }
            if(t1 % 3 == 0) {
                out.println(1);
            } else {
                out.println(0);
            }
            out.close();
            return;
        }
        if(m == 3) {
            int[] t = new int[m+1];
            for (int i = 0; i < n; i++) {
                t[a[i]]++;
            }
            if(t[1] == 0 || t[2] == 0 || t[3] == 0) {
                if(t[1] % 3 == 0 && t[2] % 3 == 0 && t[3] % 3 == 0) {
                    out.println(1);
                } else {
                    out.println(0);
                }
                out.close();
                return;
            }
            int ans = 0;
            for (int i = 0; i <= n/3; i++) {
                int[] t1 = new int[m+1];
                for (int j = 0; j <= m; j++) {
                    t1[j] = t[j];
                }
                for (int j = 0; j <= m; j++) {
                    t1[j] -= i;
                }
                int y = 0;
                for (int j = 0; j <= m; j++) {
                    if(t1[j] % 3 != 0) {
                        y = 1;
                        break;
                    }
                }
                if(y == 0) {
                    ans++;
                }
            }
            out.println(ans);
        }
        out.close();
    }

    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter out = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");


    public static boolean hasNext() throws IOException {
        if (in.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            in = new StringTokenizer(s);
            if (in.hasMoreTokens()) return true;
        }
        return false;
    }

    public static String nextToken() throws IOException {
        while (!in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}